<template>
    <div>
        <table class="table is-bordered is-fullwidth">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>お客様名</th>
                    <th>メールアドレス</th>
                    <th>商品種別</th>
                    <th>商品名</th>
                    <th>希望価格</th>
                    <th>状況</th>
                </tr>
            </thead>
            <tfoot>
                <tr>
                    <th>ID</th>
                    <th>お客様名</th>
                    <th>メールアドレス</th>
                    <th>商品種別</th>
                    <th>商品名</th>
                    <th>希望価格</th>
                    <th>状況</th>
                </tr>
            </tfoot>
            <tbody>
                <tr v-for="(item, index) of items" :key="index" @click="detailLink(item.id)">
                    <th>{{item.id}}</th>
                    <td>{{item.name}}</td>
                    <td>{{item.email}}</td>
                    <td>{{item.items[0].item_type}}</td>
                    <td>{{item.items[0].item_name}}</td>
                    <td>{{item.items[0].item_price}}</td>
                    <td>
                        <div class="select">
                            <select v-model="item.items[0].status" @change="changeStatus(item.items[0])">
                                <option value="1">査定依頼中</option>
                                <option value="2">概算査定済み</option>
                                <option value="3">品物受け取り中</option>
                                <option value="4">正規査定中</option>
                                <option value="5">完了済み</option>
                            </select>
                        </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <ul>
            <li v-for="(link,index) of links" @click="getPage(link.label)" :key="index" :class="getClassName(link.active)">{{link.label}}</li>
        </ul>
    </div>
</template>

<script>

import {inject, ref, toRef} from 'vue';
import {useRouter} from 'vue-router';

export default {
    name: 'AdminTop',
    setup() {
        const { state, getItems, updateItem } = inject('itemStore');
        const page = ref(1);
        const router = useRouter();

        const items = toRef(state, 'items');
        const links = toRef(state, 'links');

        const getPage = (pageLabel) => {
            page.value = pageLabel;
            getItems(pageLabel);
        }

        const getClassName = (active) => {
            if (active) {
                return 'on-active';
            } else {
                return 'non-active';
            }
        }

        const changeStatus = (item) => {
            if(confirm(`${item.id}の状態を更新しますか？`)) {
                updateItem(item, page.value);
            }
        }

        const detailLink = (id) => {
            router.push(`/detail/${id}`);
        }


        return {
            items,
            links,
            page,
            getClassName,
            getPage,
            changeStatus,
            detailLink
        }
    },
}
</script>

<style>
li {
    padding: 20px;
    margin: 5px;
    display: inline;
    border: 1px solid gainsboro;
    cursor: pointer;
}
li:hover {
    background-color: aqua;
}
li.on-active {
    background-color: aqua;
}
.data-table {
    height: 600px;
}
</style>